﻿Imports MutterUhrControl.header
Public Class MutterUhrControlMain
    Public Const SERIAL_BAUD_RATE = 9600
    Public Const SERIAL_STOP_BITS = 1
    Public Const SERIAL_DATA_BITS = 8
    Public Const SERIAL_PARITY = System.IO.Ports.Parity.None
    Public Const SERIAL_HANDSHAKE = System.IO.Ports.Handshake.None
    Private Const REGISTRY_CURRENTUSER_ROOT_PATH = "Software"
    Private Const REGISTRY_CURRENTUSER_VENDOR_PATH = "RSoft"
    Public Const REGISTRY_CURRENTUSER_APPLICATION_PATH = "Motherclock"
    Public Const REGISTRY_KEY_COMPORT = "COMPort"
    Public Const REGISTRY_KEY_LANGUAGE = "Language"
    Public Const DEFAULT_LANGUAGE = "DE"
    Public Const DEFAULT_PULSEWIDTH = 4
    Public oRegApplication As RegistryKey
    Public sCOMPort As String
    Public oCOMPort As System.IO.Ports.SerialPort
    ' Damit beim start automatisch bersucht wird sich zu verbinden: TRUE
    Public bSerialConnected As Boolean = False
    Private bIsSyncingForward As Boolean = False
    Private bIsSyncingWaiting As Boolean = False
    Public bSyncMode24h As Boolean = False
    Public iPulsWidthIn100ms As Int16 = 0
    Private bNewClockTimeInc As Boolean = False
    Public bSlaveClockPaused As Boolean = False
    Public bDCF77Enabled As Boolean = False
    Public sLanguage As String
    'Private oTranslatedStrings As TranslatedString
    Private oTranslatedStrings As TranslatedString = New header.TranslatedString("")
    Private oDCF77 As New DCF77DateTime(oTranslatedStrings)
    Private oPowerFaultDate As New PowerFaultDateTime(oTranslatedStrings)
    ' Strings fürs Menu
    Private Sub MutterUhrControlMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ComSettings.ComboBoxComPorts.Items.Clear()
        For Each sPort In System.IO.Ports.SerialPort.GetPortNames
            ComSettings.ComboBoxComPorts.Items.Add(sPort)
        Next
        If ComSettings.ComboBoxComPorts.Items.Count >= 1 Then
            Dim oRegRoot As RegistryKey
            Dim oRegVendor As RegistryKey
            oRegRoot = Registry.CurrentUser.OpenSubKey("Software", True)
            oRegVendor = oRegRoot.OpenSubKey(REGISTRY_CURRENTUSER_VENDOR_PATH, True)
            ' If TypeName(oRegVendor) = "Nothing" Then
            If IsNothing(oRegVendor) Then
                oRegVendor = oRegRoot.CreateSubKey(REGISTRY_CURRENTUSER_VENDOR_PATH)
            End If
            oRegApplication = oRegVendor.OpenSubKey(REGISTRY_CURRENTUSER_APPLICATION_PATH, True)
            If IsNothing(oRegApplication) Then
                oRegApplication = oRegVendor.CreateSubKey(REGISTRY_CURRENTUSER_APPLICATION_PATH)
            End If
            sCOMPort = oRegApplication.GetValue(REGISTRY_KEY_COMPORT)
            If IsNothing(sCOMPort) Then
                oRegApplication.SetValue(REGISTRY_KEY_COMPORT, "", RegistryValueKind.String)
                ComSettings.ShowDialog()
            ElseIf sCOMPort.Length <= 1 Then
                ComSettings.ShowDialog()
                'oRegApplication.SetValue(REGISTRY_KEY_COMPORT, "")
            End If
            oTranslatedStrings.Language = oRegApplication.GetValue(REGISTRY_KEY_LANGUAGE)
            If IsNothing(oTranslatedStrings.Language) Then
                oRegApplication.SetValue(REGISTRY_KEY_LANGUAGE, DEFAULT_LANGUAGE, RegistryValueKind.String)
                oTranslatedStrings.Language = DEFAULT_LANGUAGE
            End If
            fUpdateLanguageMenuChecked(oTranslatedStrings.Language)
            ' SlaveTimeStationClockControl.Time = Now
            sCOMPort = oRegApplication.GetValue(REGISTRY_KEY_COMPORT)
            'LabelDebug.Text = TypeName(sCOMPort)
            'If oRegApplication.GetValue Then
            ' LabelDebug.Text = oRegRoot.GetType.ToString
            If ComSettings.ComboBoxComPorts.Items.Contains(sCOMPort) Then
                If fOpenCOM(sCOMPort, SERIAL_BAUD_RATE, SERIAL_DATA_BITS, SERIAL_PARITY, SERIAL_STOP_BITS, SERIAL_HANDSHAKE, oCOMPort) Then
                    fUpdateStatusBarCOMPort(oCOMPort, sCOMPort)
                    ' Me.Text = Me.Text & " Version "
                    ' TabControl1.TabPages.Remove(TabPageSync2)
                    ' TabControl1.TabPages.Remove(TabPageDCF77)
                    fGetClockModes()
                    If bSerialConnected Then
                        fUpdateClientTime()
                        fUpdateNameAndFirmwareVersion()
                        fUpdateLastPowerFault(oPowerFaultDate)
                        fUpdateClientTimeLastPowerFault()
                        fUpdateDCF77Time(oDCF77)
                        TimerUpdateStatus.Enabled = True
                    End If
                Else
                    MsgBox("Cannot open COM Port " & sCOMPort, MsgBoxStyle.Critical, "Error")
                End If

                'MsgBox(PauseTheClockToolStripMenuItem.Image.ToString)
                'fGetStatus(oCOMPort, "gst", bSerialLock, Nothing)
                'TabControl1.TabPages.Insert(1, TabPageSync2)
            Else
                oRegApplication.DeleteValue(REGISTRY_KEY_COMPORT)
                sCOMPort = ""
            End If
        Else
            MsgBox("No COM Ports found! Exiting Application" & vbCrLf & vbCrLf & "You need at least one COM Port!", MsgBoxStyle.Critical, "ERR0R")
            Application.Exit()
        End If
        fSetLanguageStrings(oTranslatedStrings.Language)
    End Sub


    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub COMPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COMPortToolStripMenuItem.Click
        ComSettings.ShowDialog()
    End Sub
    Public Function fOpenCOM(ByVal sCOMPort, ByVal iBAUDRate, ByVal iDataBits, ByVal iParity, ByVal iStopBits, ByVal iHandShake, ByRef oCOM)
        If IsNothing(oCOM) Then
            oCOM = New System.IO.Ports.SerialPort(sCOMPort, iBAUDRate, iParity, iDataBits, iStopBits)
            fOpenCOM = True
            Try
                oCOM.Open()
                fUpdateStatusBarCOMPort(oCOM, sCOMPort)
            Catch oEx As Exception
                fOpenCOM = False
                MsgBox(oEx.Message, 0, oTranslatedStrings.ErrorMessage)
            End Try
        ElseIf TypeName(oCOM) = "SerialPort" Then
            System.Diagnostics.Debug.Print("ElseIF fOpenCom" + oCOM.PortName + " " + sCOMPort)
            If oCOM.PortName <> sCOMPort Then
                oCOM.Close()
                oCOM.PortName = sCOMPort
                fOpenCOM = True
                Try
                    oCOM.Open()
                    fUpdateStatusBarCOMPort(oCOM, sCOMPort)
                Catch oEx As Exception
                    fOpenCOM = False
                    MsgBox(oEx.Message, 0, oTranslatedStrings.ErrorMessage)
                End Try
            Else
                If Not oCOM.IsOpen Then
                    fOpenCOM = True
                    Try
                        oCOM.Open()
                    Catch oEx As Exception
                        fOpenCOM = False
                        MsgBox(oEx.Message, 0, oTranslatedStrings.ErrorMessage)
                    End Try
                Else
                    fOpenCOM = True
                End If
            End If
        Else
                System.Diagnostics.Debug.Print("Else fOpenCom")
                fOpenCOM = False
            End If
    End Function

    Private Function fGetStatus(ByRef oSerialPort As System.IO.Ports.SerialPort, ByVal sCommand As String, ByRef aRetValues As Array)
        Dim sParameters As String = ""
        Dim aStatusBlocks As Array
        Dim hCommandReturnLength As New Hashtable
        'While Not bSerialLock
        'Dim iLoop As Int64 = 0
        'iLoop += 1
        'Label1.Text = iLoop.ToString
        'System.Threading.Thread.Sleep(100)
        ' Wait until Serial is not locked
        'End While
        hCommandReturnLength.Add("gv", 2)
        hCommandReturnLength.Add("gst", 3)
        hCommandReturnLength.Add("gnt", 3)
        hCommandReturnLength.Add("gd7", 12)
        hCommandReturnLength.Add("gda", 61)
        hCommandReturnLength.Add("glp", 7)
        hCommandReturnLength.Add("ggs", 7)
        hCommandReturnLength.Add("gls", 2)
        ' Blocks ; sperated Parameters , sperated
        ' 0: FirmwareVersion 0=Version
        ' 1: ClientTime = 0=Hour,1=Minute,2=Second,3=Paused

        If hCommandReturnLength.ContainsKey(sCommand) Then
            If fExecuteCommandSerial(oSerialPort, "_stat", sCommand, sParameters) Then
                ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateConnected
                aStatusBlocks = sParameters.Split(";")
                ' Block 0 FirmwareVersion
                ' ToolStripStatusLabelFirmware.Text = "Firmwareversion: " & aStatusBlocks(0).ToString.Split(",")(1)
                ' Block 1 SlaveTimes
                'MsgBox("BLOCKS: " & aStatusBlocks.GetLength(0) & " " & sCommand & " " & sParameters)
                If aStatusBlocks.GetLength(0) = 2 Then
                    If aStatusBlocks(1) = "OK" Then
                        aRetValues = aStatusBlocks(0).ToString.Split(",")
                        'MsgBox("COM:" & sCommand & " " & aRetValues.GetLength(0) & " " & aRetValues.GetValue(0))
                        If aRetValues.GetLength(0) = hCommandReturnLength.Item(sCommand) Then
                            'StationClockControl1.Time = New DateTime(aParameterBlocks(0) & ":" & aParameterBlocks(1) & ":" & aParameterBlocks(2))
                            'fSetClockTime(Clock1, aParameterBlocks(0) & ":" & aParameterBlocks(1) & ":" & aParameterBlocks(2))
                            ToolStripStatusLabelConnted.Text = "Status: Ok" & "(" & UCase(sCommand) & ")"
                            If Not bSerialConnected Then
                                fOnConnectSerial()
                            End If
                            Return (True)
                        Else
                            ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateProtokollError & "3" & "(" & UCase(sCommand) & ")"
                            If bSerialConnected Then
                                fOnDisconnectSerial()
                            End If
                            Return (False)
                        End If
                    Else
                        ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateProtokollError & "2" & "(" & UCase(sCommand) & ")"
                        If bSerialConnected Then
                            fOnDisconnectSerial()
                        End If
                        Return (False)
                    End If
                Else
                    ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateProtokollError & "1" & "(" & UCase(sCommand) & ")"
                    If bSerialConnected Then
                        fOnDisconnectSerial()
                    End If
                    Return (False)
                End If
            Else
                ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateTimeout & "(" & UCase(sCommand) & ")"
                If bSerialConnected Then
                    fOnDisconnectSerial()
                End If
                Return (False)
            End If
        Else
            MsgBox(oTranslatedStrings.Command & ":" & sCommand)
            ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateUnknownCommand & "(" & UCase(sCommand) & ")"
            If bSerialConnected Then
                fOnDisconnectSerial()
            End If
            Return (False)
        End If
    End Function
    Private Function fExecuteCommandSerial(ByRef oSerialPort As System.IO.Ports.SerialPort, ByVal sCommand As String, ByVal sParameter As String, ByRef sReturn As String)
        Dim iReadChar As Integer, bNothingReceived As Boolean, sReceivedCommandString, sReceivedReturnString As String, sSendCommand As String
        ' Dim oSavedCursor As System.Windows.Forms.Cursor
        If oSerialPort.IsOpen Then
            ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateConnecting
            oSerialPort.Write(Chr(3))
            System.Threading.Thread.Sleep(100)
            oSerialPort.DiscardInBuffer()
            sSendCommand = sCommand & ";" & sParameter & ";" & Chr(13)
            oSerialPort.Write(sSendCommand)
            sReceivedCommandString = ""
            sReceivedReturnString = ""
            bNothingReceived = False
            oSerialPort.ReadTimeout = 1000
            ' Kommando echo lesen
            'oSavedCursor = Cursor.Current
            Do
                'System.Threading.Thread.Sleep(1200)
                Try
                    'Cursor.Current = Cursors.WaitCursor
                    iReadChar = oSerialPort.ReadChar
                    ' Bis \r aber mindestens bis das Kommando wieder empfangen wurde
                    If Not (iReadChar = 13 Or iReadChar = 10) Then
                        sReceivedCommandString &= System.Convert.ToChar(iReadChar)
                    End If
                    ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateConnected
                Catch ex As Exception
                    bNothingReceived = True
                    'MsgBox("EXCEPTION:" & ex.Message, 0, "ex")
                End Try
            Loop Until iReadChar = 13 Or bNothingReceived
            ' Ergebnis lesen
            If bNothingReceived Then
                ' Timeout
                ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateTimeout & "(" & sCommand & ")"
                Return (False)
                Exit Function
            End If
            'Cursor.Current = oSavedCursor
            Do
                Try
                    'Cursor.Current = Cursors.WaitCursor
                    iReadChar = oSerialPort.ReadChar
                    ' Bis \r aber mindestens bis das Kommando wieder empfangen wurde
                    If Not (iReadChar = 13 Or iReadChar = 10) Then
                        sReceivedReturnString &= System.Convert.ToChar(iReadChar)
                    End If
                    ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateConnected
                Catch ex As Exception
                    bNothingReceived = True
                    'MsgBox("EXCEPTION:" & ex.Message, 0, "ex")
                End Try
            Loop Until iReadChar = 13 Or bNothingReceived
            'Cursor.Current = oSavedCursor
            If bNothingReceived Then
                ' Timeout
                ToolStripStatusLabelConnted.Text = oTranslatedStrings.StateTimeout & "(" & sCommand & ")"
                Return (False)
                Exit Function
            End If
            ' KOmmando wird ebenfalls mit zurückgegeben, aus String entfernen
            'MsgBox(sReceivedReturnString & "LENREC: " & sReceivedReturnString.Length & "LEN COM: " & sSendCommand.Length)
            sReturn = sReceivedReturnString '.Substring(sSendCommand.Length)
            Return (True)
        Else
            Return (False)
        End If
    End Function
    Private Sub fOnDisconnectSerial()
        SlaveTimeStationClockControl.ClockDisabled = True
        bSerialConnected = False
        ConnectToolStripMenuItem.Text = oTranslatedStrings.Connect
        ConnectToolStripMenuItem.Image = MutterUhrControl.My.Resources.Connect
        TimeOnSlavesLabel.Text = "--.--.--"
        bDCF77Enabled = False
        DCF77GroupBox.Visible = False
        SyncingGroupBox.Visible = False
        PauseSlavesLabel.Text = oTranslatedStrings.IsDisconnected
        bSlaveClockPaused = False
        SlaveTimeStationClockControl.ClockDisabled = True
        ' Me.Text = "Masterclock Controlprogram"
        FirmwareVersionToolStripStatusLabel.Text = oTranslatedStrings.Firmwareversion
        TimeOnSlavesLabel.Text = "--:--:--"
        SetTimeOnSlavesToolStripMenuItem.Enabled = False
        PauseTheClockToolStripMenuItem.Enabled = False
        DCF77ToolStripMenuItem.Enabled = False
        SetSyncoToolStripMenuItem.Enabled = False
        SetOutputpulsewidthToolStripMenuItem.Enabled = False
        TimerUpdateStatus.Enabled = False
    End Sub
    Private Sub fOnConnectSerial()
        SlaveTimeStationClockControl.ClockDisabled = False
        bSerialConnected = True
        'MsgBox("DIS")
        ConnectToolStripMenuItem.Text = oTranslatedStrings.Disconnect
        ConnectToolStripMenuItem.Image = MutterUhrControl.My.Resources.Disconnect
        SetTimeOnSlavesToolStripMenuItem.Enabled = True
        PauseTheClockToolStripMenuItem.Enabled = True
        SetSyncoToolStripMenuItem.Enabled = True
        DCF77ToolStripMenuItem.Enabled = True
        SetOutputpulsewidthToolStripMenuItem.Enabled = True
        bSlaveClockPaused = True
        fUpdateNameAndFirmwareVersion()
        fUpdateLastPowerFault(oPowerFaultDate)
        fUpdateClientTimeLastPowerFault()
        TimerUpdateStatus.Enabled = True
    End Sub
    Private Sub fUpdateStatusBarCOMPort(ByVal oCOMPort As System.IO.Ports.SerialPort, ByVal sPort As String)
        If sPort.Length >= 4 Then
            If Not IsNothing(oCOMPort) Then
                If oCOMPort.IsOpen Then
                    ToolStripStatusLabelCOMPort.Text = oCOMPort.PortName & ": " & oTranslatedStrings.Open
                Else
                    ToolStripStatusLabelCOMPort.Text = oCOMPort.PortName & ": " & oTranslatedStrings.Closed
                End If
            End If
        Else
            ToolStripStatusLabelCOMPort.Text = "COM Port: " & oTranslatedStrings.COMPortNotSelected
        End If
    End Sub
    Private Sub fGetClockModes()
        Dim aClockModes(5)
        If fGetStatus(oCOMPort, "ggs", aClockModes) Then
            ' Block 6 Get Global State
            'Clock Paused; New Clock Time Inc; Ready4Sync; iTimeDiff; DCF77 On;
            If aClockModes.GetValue(4) = "1" Then
                bDCF77Enabled = True
                DCF77StateLabel.Text = oTranslatedStrings.Enabled
                DCF77GroupBox.Visible = True
                DCF77ToolStripMenuItem.Text = oTranslatedStrings.DCF77DisableClock
                MoveSlavesToExactThisTimeToolStripMenuItem.Enabled = False
                MoveSlavesToTimeToolStripMenuItem.Enabled = False

            Else
                bDCF77Enabled = False
                DCF77StateLabel.Text = oTranslatedStrings.Disabled
                DCF77GroupBox.Visible = False
                DCF77ToolStripMenuItem.Text = oTranslatedStrings.DCF77EnableClock
                MoveSlavesToExactThisTimeToolStripMenuItem.Enabled = True
                MoveSlavesToTimeToolStripMenuItem.Enabled = True
            End If
            If aClockModes.GetValue(0) = "0" Then
                PauseSlavesLabel.Text = oTranslatedStrings.Halted
                PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.ContinueSlaveClocks
                PauseTheClockToolStripMenuItem.Image = MutterUhrControl.My.Resources.Play
                bSlaveClockPaused = True
            Else
                PauseSlavesLabel.Text = oTranslatedStrings.Running
                PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.HaltSlaveClocks
                PauseTheClockToolStripMenuItem.Image = MutterUhrControl.My.Resources.halt
                bSlaveClockPaused = False
            End If
            If aClockModes.GetValue(1) = "1" Then
                bNewClockTimeInc = True
            Else
                bNewClockTimeInc = False
            End If
            ' iTimeDIff && 
            ' DebugLabel.Text = "R4S:" & aClockModes.GetValue(2) & " TIMEDIFF" & aClockModes.GetValue(3) & " " & bIsSyncingForward & " " & bIsSyncingWaiting
            If Convert.ToInt32(aClockModes.GetValue(3)) > 0 And aClockModes.GetValue(2) = "1" Then
                bIsSyncingForward = True
                bIsSyncingWaiting = False
                SyncingGroupBox.Text = oTranslatedStrings.SyncActiveForward
                If Not SyncingGroupBox.Visible Then
                    SyncingGroupBox.Visible = True
                End If
                fUpdateNewClientTime(aClockModes.GetValue(3))
            ElseIf Convert.ToInt32(aClockModes.GetValue(3)) < 0 And aClockModes.GetValue(2) = "1" Then
                bIsSyncingWaiting = True
                bIsSyncingForward = False
                SyncingGroupBox.Text = oTranslatedStrings.SyncActiveWaiting
                If Not SyncingGroupBox.Visible Then
                    SyncingGroupBox.Visible = True
                End If
                fUpdateNewClientTime(aClockModes.GetValue(3))
            Else
                bIsSyncingForward = False
                bIsSyncingWaiting = False
                SyncingGroupBox.Visible = False
            End If
            If aClockModes.GetValue(5) = 1 Then
                bSyncMode24h = True
                Label24hModeValue.Text = oTranslatedStrings.M24h
                ' SyncMode24h.RadioButton24h.Checked = True
            Else
                bSyncMode24h = False
                Label24hModeValue.Text = oTranslatedStrings.M12h
                ' SyncMode24h.RadioButton12h.Checked = True
            End If
            If System.Convert.ToInt16(aClockModes.GetValue(6)) >= 2 And System.Convert.ToInt16(aClockModes.GetValue(6)) <= 80 Then
                iPulsWidthIn100ms = System.Convert.ToInt16(aClockModes.GetValue(6))
                LabelOutputPulseWidthValue.Text = iPulsWidthIn100ms.ToString & "00 ms"
            End If
        Else
            DCF77GroupBox.Visible = False
            PauseSlavesLabel.Text = oTranslatedStrings.IsDisconnected
            bSlaveClockPaused = False
            bNewClockTimeInc = False
        End If
    End Sub
    Private Sub fUpdateClientTime()
        Dim aReturnParameters(3) As String
        ' Hour, Minute, Second
        If fGetStatus(oCOMPort, "gst", aReturnParameters) Then
            SlaveTimeStationClockControl.ClockDisabled = False
            SlaveTimeStationClockControl.Time = New DateTime(Now.Year, Now.Month, Now.Day, Convert.ToInt32(aReturnParameters.GetValue(0)), Convert.ToInt32(aReturnParameters.GetValue(1)), Convert.ToInt32(aReturnParameters.GetValue(2)))
            'TimeOnSlavesLabel.Text = Convert.ToInt32(aReturnParameters.GetValue(0)) & ":" & Convert.ToInt32(aReturnParameters.GetValue(1)) & ":" & Convert.ToInt32(aReturnParameters.GetValue(2))
            fUpdateClientTimeLabelFromClock()
        End If
    End Sub
    Private Sub fUpdateClientTimeLastPowerFault()
        Dim aReturnParameters(2) As String
        If fGetStatus(oCOMPort, "gls", aReturnParameters) Then
            If Not Convert.ToInt64(aReturnParameters.GetValue(1)) = &HFF Then
                PowerFaultTimeOnSlavesLabel.Text = fGetIntAS2DigitString(Convert.ToInt16(aReturnParameters.GetValue(0))) & ":" & fGetIntAS2DigitString(Convert.ToInt16(aReturnParameters.GetValue(1)))
            Else
                PowerFaultTimeOnSlavesLabel.Text = oTranslatedStrings.NoPowerfaultDetected
            End If
        End If
    End Sub
    Private Sub fUpdateLastPowerFault(ByRef oPF As PowerFaultDateTime)
        Dim aReturnParameters(7) As String
        If fGetStatus(oCOMPort, "glp", aReturnParameters) Then
            If Not Convert.ToInt64(aReturnParameters.GetValue(2)) = &HFF Then
                oPowerFaultDate.inall = aReturnParameters
                PowerFaultDateOnSlavesLabel.Text = oPowerFaultDate.datetimestring
            Else
                PowerFaultDateOnSlavesLabel.Text = oTranslatedStrings.NoPowerfaultDetected
            End If
        End If
    End Sub
    Private Sub fUpdateDCF77Time(ByRef oDCF As DCF77DateTime)
        Dim aReturnParameters(11) As String
        ' Hour, Minute, Second
        If fGetStatus(oCOMPort, "gd7", aReturnParameters) Then
            oDCF.inall = aReturnParameters
            DCF77ReceivedDateLabel.Text = oDCF.datetimestring
            DCF77LastResultLabel.Text = oDCF.lastresultstring
            DCF77CurrentStateLabel.Text = oDCF.currentstatestring
            'NewClockTimeStationClockControl.Time = New DateTime(Now.Year, Now.Month, Now.Day, aReturnParameters.GetValue(0), aReturnParameters.GetValue(1), aReturnParameters.GetValue(2))
        Else
            fOnDisconnectSerial()
        End If
    End Sub
    Private Sub fUpdateNewClientTime(ByVal iMinutesLeft)
        Dim aReturnParameters(3) As String
        ' Hour, Minute, Second
        If fGetStatus(oCOMPort, "gnt", aReturnParameters) Then
            NewClockTimeStationClockControl.Time = New DateTime(Now.Year, Now.Month, Now.Day, Convert.ToInt32(aReturnParameters.GetValue(0)), Convert.ToInt32(aReturnParameters.GetValue(1)), Convert.ToInt32(aReturnParameters.GetValue(2)))
            If iMinutesLeft < 0 Then iMinutesLeft *= -1
            MinutesLeftLabel.Text = iMinutesLeft
            fUpdateNewClientTimeLabelFromClock()
            'SyncSlavesToLabel.Text = aReturnParameters.GetValue(0) & ":" & aReturnParameters.GetValue(1) & ":" & aReturnParameters.GetValue(2)
        End If
    End Sub
    Private Sub fUpdateNewClientTimeLabelFromClock()
        SyncSlavesToLabel.Text = fGetIntAS2DigitString(NewClockTimeStationClockControl.Time.Hour) & ":" & fGetIntAS2DigitString(NewClockTimeStationClockControl.Time.Minute) & ":" & fGetIntAS2DigitString(NewClockTimeStationClockControl.Time.Second)
    End Sub
    Private Sub fUpdateClientTimeLabelFromClock()
        TimeOnSlavesLabel.Text = fGetIntAS2DigitString(SlaveTimeStationClockControl.Time.Hour) & ":" & fGetIntAS2DigitString(SlaveTimeStationClockControl.Time.Minute) & ":" & fGetIntAS2DigitString(SlaveTimeStationClockControl.Time.Second)
    End Sub
    Private Sub fUpdateNameAndFirmwareVersion()
        Dim aReturnParameters(2) As String
        If fGetStatus(oCOMPort, "gv", aReturnParameters) Then
            Me.Text = oTranslatedStrings.ProgramName & ": " & aReturnParameters.GetValue(0)
            FirmwareVersionToolStripStatusLabel.Text = oTranslatedStrings.Firmwareversion & aReturnParameters.GetValue(1)
        End If
    End Sub

    Private Sub TimerUpdateStatus_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TimerUpdateStatus.Tick
        Static Dim iSecondCount As Integer = 0
        fUpdateStatusBarCOMPort(oCOMPort, sCOMPort)
        If iSecondCount >= 9 Then iSecondCount = 0
        'If bNewClockTimeInc And (bIsSyncingForward Or bIsSyncingWaiting) And bSerialConnected Then
        'NewClockTimeStationClockControl.Time = NewClockTimeStationClockControl.Time.AddSeconds(1)
        'fUpdateNewClientTimeLabelFromClock()
        'End If
        'If bSerialConnected And Not bSlaveClockPaused And Not bIsSyncingWaiting And Not bIsSyncingForward Then
        'SlaveTimeStationClockControl.Time = SlaveTimeStationClockControl.Time.AddSeconds(1)
        'fUpdateClientTimeLabelFromClock()
        'End If
        'If bIsSyncingForward Then
        ' SlaveTimeStationClockControl.Time = SlaveTimeStationClockControl.Time.AddMinutes(1)
        'fUpdateClientTimeLabelFromClock()
        'End If
        If bSerialConnected Then
            fGetClockModes()
            ' Time on slave Tab
            If TabControl1.SelectedIndex = 0 Then
                fUpdateClientTime()
                If bIsSyncingForward Or bIsSyncingWaiting Then
                    ' fUpdateClientTimeLabelFromClock()
                End If
                If iSecondCount Mod 5 = 0 Then
                    fUpdateLastPowerFault(oPowerFaultDate)
                ElseIf (iSecondCount + 1) Mod 5 = 0 Then
                    fUpdateClientTimeLastPowerFault()
                End If
            ElseIf TabControl1.SelectedIndex = 1 And bDCF77Enabled Then
                If iSecondCount Mod 2 = 0 Then
                    fUpdateDCF77Time(oDCF77)
                End If
            End If
            If iSecondCount Mod 5 = 0 Then
                fUpdateNameAndFirmwareVersion()
            End If
        End If
        iSecondCount += 1
    End Sub

    Private Sub ConnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If ConnectToolStripMenuItem.Text = oTranslatedStrings.Connect Then
            ' Connect
            fGetClockModes()
        Else
            ' Disconnect
            fOnDisconnectSerial()
        End If
    End Sub
    Private Sub SetTimeOnSlavesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetTimeOnSlavesToolStripMenuItem.Click
        Dim sReturn As String = ""
        If SetMasterToTimeOnSlaves.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            If fExecuteCommandSerial(oCOMPort, "_smt", SetMasterToTimeOnSlaves.HourSetMasterNumericUpDown.Value.ToString & ":" & SetMasterToTimeOnSlaves.MinuteSetMasterNumericUpDown.Value.ToString, sReturn) Then
                If sReturn = "OK" Then
                    'MsgBox(oTranslatedStrings.SuccessMaster2Slave, 0, oTranslatedStrings.Info)
                Else
                    MsgBox(oTranslatedStrings.ErrorMaster2Slave & sReturn, 16, oTranslatedStrings.ErrorMessage)
                End If
            Else
                MsgBox(oTranslatedStrings.ErrorMaster2SlaveTimeout, 16, oTranslatedStrings.ErrorMessage)
            End If
        Else
        End If
    End Sub

    Private Sub MoveSlavesToExactThisTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MoveSlavesToExactThisTimeToolStripMenuItem.Click
        Dim sReturn As String = ""
        If SetSlavesToExactTime.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            If fExecuteCommandSerial(oCOMPort, "_nst", SetSlavesToExactTime.HourSetSlaveExactNumericUpDown.Value.ToString & ":" & SetSlavesToExactTime.MinuteSetSlaveExactNumericUpDown.Value.ToString, sReturn) Then
                If sReturn = "OK" Then
                    'MsgBox(oTranslatedStrings.SuccessFullySet, 0, oTranslatedStrings.Info)
                Else
                    MsgBox(oTranslatedStrings.SetFailed & sReturn, 16, oTranslatedStrings.ErrorMessage)
                End If
            Else
                MsgBox(oTranslatedStrings.SetFailedTimeout, 16, oTranslatedStrings.ErrorMessage)
            End If
        End If
    End Sub

    Private Sub MoveSlavesToTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MoveSlavesToTimeToolStripMenuItem.Click
        Dim sReturn As String = ""
        If SetSlaveTime.ShowDialog = Windows.Forms.DialogResult.OK Then
            If fExecuteCommandSerial(oCOMPort, "_ast", SetSlaveTime.HourSetSlaveTimeNumericUpDown.Value.ToString & ":" & SetSlaveTime.MinuteSetSlaveTimeExactNumericUpDown.Value.ToString, sReturn) Then
                If sReturn = "OK" Then
                    'MsgBox(oTranslatedStrings.SuccessFullySet, 0, oTranslatedStrings.Info)
                Else
                    MsgBox(oTranslatedStrings.SetFailed & sReturn, 16, oTranslatedStrings.ErrorMessage)
                End If
            Else
                MsgBox(oTranslatedStrings.SetFailedTimeout, 16, oTranslatedStrings.ErrorMessage)
            End If
        End If
    End Sub

    Private Sub PauseTheClockToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PauseTheClockToolStripMenuItem.Click
        Dim sReturn As String = ""
        'Dim sText As String
        'sText = oTranslatedStrings.SlaveClockCurrently
        'If bSlaveClockPaused Then
        ' sText &= oTranslatedStrings.SlaveClocksHaltedContinueQuestion
        'Else
        'sText &= oTranslatedStrings.SlaveClocksRunningHaltQuestion
        'End If
        'If MsgBox(sText, MsgBoxStyle.OkCancel Or MsgBoxStyle.Question, "Slave(s) clock mode") = MsgBoxResult.Ok Then
        If bSlaveClockPaused Then
            PauseSlaves.RadioButtonContinue.Checked = False
            PauseSlaves.RadioButtonPause.Checked = True
        Else
            PauseSlaves.RadioButtonContinue.Checked = True
            PauseSlaves.RadioButtonPause.Checked = False
        End If
        If PauseSlaves.ShowDialog = Windows.Forms.DialogResult.OK Then
            If PauseSlaves.RadioButtonContinue.Checked Then
                If fExecuteCommandSerial(oCOMPort, "_pst", "0", sReturn) Then
                    If sReturn = "OK" Then
                        'MsgBox(oTranslatedStrings.SuccessFullySet, 0, oTranslatedStrings.Info)
                        PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.HaltSlaveClocks
                        PauseTheClockToolStripMenuItem.Image = MutterUhrControl.My.Resources.halt
                        fGetClockModes()
                    Else
                        MsgBox(oTranslatedStrings.SetContinueFailed & sReturn, 16, oTranslatedStrings.ErrorMessage)
                    End If
                Else
                    MsgBox(oTranslatedStrings.SetFailedTimeout, 16, oTranslatedStrings.ErrorMessage)
                End If
            Else
                If fExecuteCommandSerial(oCOMPort, "_pst", "1", sReturn) Then
                    If sReturn = "OK" Then
                        PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.ContinueSlaveClocks
                        PauseTheClockToolStripMenuItem.Image = MutterUhrControl.My.Resources.Play
                        'MsgBox(oTranslatedStrings.SuccessFullySet, 1, oTranslatedStrings.Info)
                        fGetClockModes()
                    Else
                        MsgBox(oTranslatedStrings.SetHaltFailed & sReturn, 16, oTranslatedStrings.ErrorMessage)
                    End If
                Else
                    MsgBox(oTranslatedStrings.SetFailedTimeout, 16, oTranslatedStrings.ErrorMessage)
                End If
            End If
        End If
    End Sub



    Private Sub DCF77ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DCF77ToolStripMenuItem.Click
        'Dim sText As String
        'sText = oTranslatedStrings.DCF77Currently
        'If bDCF77Enabled Then
        'sText &= oTranslatedStrings.DCF77Enable2Disable
        'Else
        'sText &= oTranslatedStrings.DCF77Disable2Enable
        'End If
        'If MsgBox(sText, MsgBoxStyle.OkCancel Or MsgBoxStyle.Question, "DCF 77 clock control") = MsgBoxResult.Ok Then
        If bDCF77Enabled Then
            DCF77.RadioButtonDCF77SyncDisable.Checked = False
            DCF77.RadioButtonDCF77SyncEnable.Checked = True
        Else
            DCF77.RadioButtonDCF77SyncDisable.Checked = True
            DCF77.RadioButtonDCF77SyncEnable.Checked = False
        End If
        If DCF77.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim sReturn As String = ""
            If DCF77.RadioButtonDCF77SyncEnable.Checked Then
                If fExecuteCommandSerial(oCOMPort, "_dcf", "1", sReturn) Then
                    If sReturn = "OK" Then
                        'MsgBox(oTranslatedStrings.DCF77SuccessEnabled, 0, oTranslatedStrings.Info)
                        fUpdateDCF77Time(oDCF77)
                        fGetClockModes()

                    Else
                        MsgBox(oTranslatedStrings.DCF77ErrorEnabling, 16, oTranslatedStrings.ErrorMessage)
                    End If
                End If
            Else
                If fExecuteCommandSerial(oCOMPort, "_dcf", "0", sReturn) Then
                    If sReturn = "OK" Then
                        'MsgBox(oTranslatedStrings.DCF77SuccessDisabled, 0, oTranslatedStrings.Info)
                        fGetClockModes()
                    Else
                        MsgBox(oTranslatedStrings.DCF77ErrorDisabling, 16, oTranslatedStrings.ErrorMessage)
                    End If
                End If
            End If
        End If
    End Sub

    Private Function fGetIntAS2DigitString(ByVal iIn As Integer) As String
        If iIn <= 9 And iIn >= 0 Then
            Return ("0" & iIn.ToString)
        Else
            Return (iIn.ToString)
        End If
    End Function

    Private Sub TabPageDCF77_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabPageDCF77.Click
        fUpdateDCF77Time(oDCF77)
    End Sub

    Private Sub DeutschToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeutschToolStripMenuItem.Click
        oTranslatedStrings.Language = "DE"
        oRegApplication.SetValue(REGISTRY_KEY_LANGUAGE, oTranslatedStrings.Language)
        fSetLanguageStrings(oTranslatedStrings.Language)
        fUpdateLanguageMenuChecked(oTranslatedStrings.Language)
    End Sub

    Private Sub EnglishToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnglishToolStripMenuItem.Click
        oTranslatedStrings.Language = "EN"
        oRegApplication.SetValue(REGISTRY_KEY_LANGUAGE, oTranslatedStrings.Language)
        fSetLanguageStrings(oTranslatedStrings.Language)
        fUpdateLanguageMenuChecked(oTranslatedStrings.Language)
    End Sub
    Private Sub fUpdateLanguageMenuChecked(ByVal sLang)
        EnglishToolStripMenuItem.Checked = False
        DeutschToolStripMenuItem.Checked = False
        If sLang = "DE" Then
            DeutschToolStripMenuItem.Checked = True
        End If
        If sLang = "EN" Or Len(sLang) = 0 Then
            EnglishToolStripMenuItem.Checked = True
        End If
    End Sub


    Private Sub ConnectToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToolStripMenuItem.Click
        If ConnectToolStripMenuItem.Text = oTranslatedStrings.Connect Then
            ' Connect
            fGetClockModes()
        Else
            ' Disconnect
            fOnDisconnectSerial()
        End If
    End Sub

    Private Sub SetSyncoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetSyncoToolStripMenuItem.Click
        If bSyncMode24h Then
            Label24hModeValue.Text = oTranslatedStrings.M24h
            SyncMode24h.RadioButton24h.Checked = True
        Else
            Label24hModeValue.Text = oTranslatedStrings.M12h
            SyncMode24h.RadioButton12h.Checked = True
        End If
        If SyncMode24h.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim sReturn As String = ""
            If SyncMode24h.RadioButton24h.Checked = True Then
                If fExecuteCommandSerial(oCOMPort, "_ssm", "1", sReturn) Then
                    If sReturn = "OK" Then
                        'MsgBox(oTranslatedStrings.SetSyncMode24Successfully, 0, oTranslatedStrings.Info)
                        fGetClockModes()
                    Else
                        MsgBox(oTranslatedStrings.SetSyncMode24Failed & " " & sReturn, 16, oTranslatedStrings.ErrorMessage)
                    End If
                Else

                End If
            Else
                If fExecuteCommandSerial(oCOMPort, "_ssm", "0", sReturn) Then
                    If sReturn = "OK" Then
                        'MsgBox(oTranslatedStrings.SetSyncMode12Successfully, 0, oTranslatedStrings.Info)
                        fGetClockModes()
                    Else
                        MsgBox(oTranslatedStrings.SetSyncMode12Failed & " " & sReturn, 16, oTranslatedStrings.ErrorMessage)
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub SetOutputpulsewidthToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetOutputpulsewidthToolStripMenuItem.Click
        ' SetPulseWidth.ComboBoxPulseWidth.SelectedItem = iPulsWidthIn100ms.ToString & "00 ms"
        If SetPulseWidth.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim sReturn As String = ""
            'If fExecuteCommandSerial(oCOMPort, "_spw", (SetPulseWidth.ComboBoxPulseWidth.SelectedIndex + 2).ToString, sReturn) Then
            If fExecuteCommandSerial(oCOMPort, "_spw", (SetPulseWidth.NumericUpDownPulseWidth.Value / 100).ToString(), sReturn) Then
                If sReturn = "OK" Then
                    'MsgBox(oTranslatedStrings.SetPulseWidthSuccessfully, 0, oTranslatedStrings.Info)
                    fGetClockModes()
                Else
                    MsgBox(oTranslatedStrings.SetPulseWidthFailed & " " & sReturn, 16, oTranslatedStrings.ErrorMessage)
                End If
            End If
        End If
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        MsgBox(oTranslatedStrings.About & (FileVersionInfo.GetVersionInfo((System.Reflection.Assembly.GetExecutingAssembly()).Location)).FileVersion.ToString())




    End Sub
    Public Sub fSetLanguageStrings(ByVal sLanguageCode)
        If sLanguageCode = "DE" Then
            With Me
                .TabControl1.TabPages.Item(0).Text = "Zeit auf Nebenuhren"
                .MasterclockToolStripMenuItem.DropDownItems.Item("SettingsToolStripMenuItem").Text = "Ein&stellungen"
                .MasterclockToolStripMenuItem.DropDownItems.Item("ExitToolStripMenuItem").Text = "&Beenden"
                .CommandsToolStripMenuItem.DropDownItems.Item("SetTimeOnSlavesToolStripMenuItem").Text = "Mu&tteruhr auf Zeit von Nebenuhren setzen"
                .CommandsToolStripMenuItem.DropDownItems.Item("MoveSlavesToExactThisTimeToolStripMenuItem").Text = "Nebenuhren auf exakt diese Zeit stellen"
                .CommandsToolStripMenuItem.DropDownItems.Item("MoveSlavesToTimeToolStripMenuItem").Text = "Nebenuhren auf diese Zeit stellen."
                .LabelTimeOnSlaves.Text = "Zeit auf Nebenuhren:"
                .LabelSlaveClockState.Text = "Nebenuhren: "
                .DCF77ToolStripMenuItem.Text = "DCF77 Sychronisation aktivieren"
                .MasterclockToolStripMenuItem.Text = "Mutteruhr"
                .CommandsToolStripMenuItem.Text = "Befehle"
                .GroupBoxLastPowerfault.Text = "Status letzter Spannungsfall"
                .LabelTimeSalevePowerfault.Text = "Zeit auf Nebenuhren:"
                .LabelDate.Text = "Datum(nur im DCF77 Modus):"
                .SyncingGroupBox.Text = "Synchronisation aktiv"
                .LabelMinuteLeft.Text = "Verbleibende Minuten:"
                .LabelSyncSlavesTo.Text = "Synchronisiere Nebenuhren auf:"
                .LabelDCF.Text = "DCF 77 Nebenuhrsynchronisation ist: "
                .DCF77GroupBox.Text = "DCF77 Status"
                .LabelDCF77LastRefDate.Text = "Letzte empfangen Zeit:"
                .LabelLastResult.Text = "Letztes Ergebnis: "
                .LabelDCF77Stat.Text = "Status: "
                .LabelClockMode24h.Text = "Synchronisierungsmodus: "
                .LabelOutputPulseWidth.Text = "Ausgangspulsweite:"
                .SetSyncoToolStripMenuItem.Text = "Synchronisationmodus 12/24Stunden ändern"
                .SetOutputpulsewidthToolStripMenuItem.Text = "Ausgangspulsweite ändern"
                .HelpToolStripMenuItem.Text = "&Hilfe"
                .AboutToolStripMenuItem.Text = "Über"
            End With
            With SyncMode24h
                .Text = "Synchronisationsmodus 12/24 Stunden"
                .GroupBoxSyncmode.Text = "Synchronisationsmodus auswählen"
            End With
            With SetPulseWidth
                .Text = "Ausgangspulsbreite"
                .GroupBoxSetOutputPulseWidth.Text = "Ausgangspulsbreite ändern"
            End With
            With PauseSlaves
                .Text = "Nebenuhr(en) Starten/Anhalten"
                .GroupBoxPauseContinue.Text = "Nebenuhr(en) Modus"
                .RadioButtonContinue.Text = oTranslatedStrings.ContinueSlaveClocks
                .RadioButtonPause.Text = oTranslatedStrings.HaltSlaveClocks
            End With
            With SetSlavesToExactTime
                .Text = "Nebenuhr(en) auf exakt diese Zeit stellen"
            End With
            With SetMasterToTimeOnSlaves
                .Text = "Mutteruhr auf die Zeit der Nebenuhr(en) stellen"
            End With
            With SetSlaveTime
                .Text = "Nebenuhr(en) auf diese Zeit stellen (+Zeit die dafür gebraucht wird)"
            End With
            With DCF77
                .Text = "Synchronisation mit DCF 77"
                .GroupBoxDCF77Sync.Text = "DCF77 Synchronisation"
                .RadioButtonDCF77SyncEnable.Text = oTranslatedStrings.DCF77EnableClock
                .RadioButtonDCF77SyncDisable.Text = oTranslatedStrings.DCF77DisableClock
            End With
            With ComSettings
                .Text = "COM Port auswählen"
            End With
            If Not bSerialConnected Then
                PauseSlavesLabel.Text = oTranslatedStrings.IsDisconnected
            Else
                If bSlaveClockPaused Then
                    PauseSlavesLabel.Text = oTranslatedStrings.Halted
                Else
                    PauseSlavesLabel.Text = oTranslatedStrings.Running
                End If
            End If
        Else
            With Me
                .TabControl1.TabPages.Item(0).Text = "Time on Slaveclocks"
                .MasterclockToolStripMenuItem.DropDownItems.Item("SettingsToolStripMenuItem").Text = "&Settings"
                .MasterclockToolStripMenuItem.DropDownItems.Item("ExitToolStripMenuItem").Text = "&Exit"
                .CommandsToolStripMenuItem.DropDownItems.Item("SetTimeOnSlavesToolStripMenuItem").Text = "Set Masterclock to &Time on slaves"
                .CommandsToolStripMenuItem.DropDownItems.Item("MoveSlavesToExactThisTimeToolStripMenuItem").Text = "Move Slaveclocks to exact this time"
                .CommandsToolStripMenuItem.DropDownItems.Item("MoveSlavesToTimeToolStripMenuItem").Text = "Move Slaveclocks to this time"
                .CommandsToolStripMenuItem.DropDownItems.Item("ConnectToolStripMenuItem").Text = "Connect"
                .LabelTimeOnSlaves.Text = "Time on slaves:"
                .LabelSlaveClockState.Text = "Slaveclocks are currently: "
                .DCF77ToolStripMenuItem.Text = "Enable Clock control with DCF77"
                .MasterclockToolStripMenuItem.Text = "Masterclock"
                .CommandsToolStripMenuItem.Text = "Commands"
                .GroupBoxLastPowerfault.Text = "At last Powerfault"
                .LabelTimeSalevePowerfault.Text = "Time on slaves:"
                .LabelDate.Text = "Date(only in DCF77 Mode):"
                .SyncingGroupBox.Text = "Syncing active"
                .LabelMinuteLeft.Text = "Minutes left:"
                .LabelSyncSlavesTo.Text = "Syncing slaves to: "
                .LabelDCF.Text = "DCF 77 slave controlling : "
                .DCF77GroupBox.Text = "DCF77 State"
                .LabelDCF77LastRefDate.Text = "Last received time:"
                .LabelLastResult.Text = "Last result: "
                .LabelDCF77Stat.Text = "Current State: "
                .LabelClockMode24h.Text = "Syncronisationmode: "
                .LabelOutputPulseWidth.Text = "Outputpulsewidth: "
                .SetSyncoToolStripMenuItem.Text = "Set syncronisationmode 12h/24h"
                .SetOutputpulsewidthToolStripMenuItem.Text = "Set Outputpulsewidth"
                .HelpToolStripMenuItem.Text = "&Help"
                .AboutToolStripMenuItem.Text = "About"
            End With

            With SyncMode24h
                SyncMode24h.Text = "Set syncmode 12/24Hours"
                .GroupBoxSyncmode.Text = "Choose syncmode"
            End With
            With SetPulseWidth
                .Text = "Outputpulsewidth"
                .GroupBoxSetOutputPulseWidth.Text = "Changet outputpulsewidth"
            End With
            With PauseSlaves
                .Text = "Pause/continue Slaveclock(s)"
                .GroupBoxPauseContinue.Text = "Slaveclock(s) mode"
                .RadioButtonContinue.Text = oTranslatedStrings.ContinueSlaveClocks
                .RadioButtonPause.Text = oTranslatedStrings.HaltSlaveClocks
            End With
            With SetSlavesToExactTime
                .Text = "Set Slaveclock(s) to exact this time"
            End With
            With SetMasterToTimeOnSlaves
                .Text = "Set Masterclock to time on slave(s)"
            End With
            With SetSlaveTime
                .Text = "Set slaveclocks(Elapsed Time for set is added)"
            End With
            With DCF77
                .Text = "DCF 77 Clock control"
                .GroupBoxDCF77Sync.Text = "DCF77 Syncronisation"
                .RadioButtonDCF77SyncEnable.Text = oTranslatedStrings.DCF77EnableClock
                .RadioButtonDCF77SyncDisable.Text = oTranslatedStrings.DCF77DisableClock
            End With
            With ComSettings
                .Text = "Select COM Port"
            End With
        End If
        With ComSettings.Cancel_Button
            .Text = oTranslatedStrings.cancel
        End With
        Me.Text = oTranslatedStrings.ProgramName
        If bSerialConnected Then
            ConnectToolStripMenuItem.Text = oTranslatedStrings.Disconnect
        Else
            ConnectToolStripMenuItem.Text = oTranslatedStrings.Connect
        End If
        If bDCF77Enabled Then
            DCF77ToolStripMenuItem.Text = oTranslatedStrings.DCF77DisableClock
            DCF77StateLabel.Text = oTranslatedStrings.Enabled
        Else
            DCF77ToolStripMenuItem.Text = oTranslatedStrings.DCF77EnableClock
            DCF77StateLabel.Text = oTranslatedStrings.Disabled
        End If
        If bSlaveClockPaused Then
            PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.ContinueSlaveClocks
        Else
            PauseTheClockToolStripMenuItem.Text = oTranslatedStrings.HaltSlaveClocks
        End If
        If Not bSerialConnected Then
            PauseSlavesLabel.Text = oTranslatedStrings.IsDisconnected
        Else
            If bSlaveClockPaused Then
                PauseSlavesLabel.Text = oTranslatedStrings.Halted
            Else
                PauseSlavesLabel.Text = oTranslatedStrings.Running
            End If
        End If
        fUpdateStatusBarCOMPort(oCOMPort, sCOMPort)
    End Sub
End Class
